// ColorCursorTestDlg.cpp : implementation file
//


#include "stdafx.h"
#include "ColorCursorTest.h"
#include "ColorCursorTestDlg.h"

#include "ColorCursor.h"

HBITMAP GetCursorBitmap();

#define WIDTH 32
#define HEIGHT 32

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CColorCursorTestDlg dialog

CColorCursorTestDlg::CColorCursorTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CColorCursorTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CColorCursorTestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_hNewCursor = NULL;
}

void CColorCursorTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CColorCursorTestDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CColorCursorTestDlg, CDialog)
	//{{AFX_MSG_MAP(CColorCursorTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CREATE_CURSOR, OnCreateCursor)
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CColorCursorTestDlg message handlers

BOOL CColorCursorTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CColorCursorTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CColorCursorTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CColorCursorTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CColorCursorTestDlg::OnCreateCursor() 
{
	do
	{
		//Clear
		if(NULL != m_hSourceBitmap)
			::DeleteObject(m_hSourceBitmap);
		if(NULL != m_hAndMask)
			::DeleteObject(m_hAndMask);
		if(NULL != m_hXorMask)
			::DeleteObject(m_hXorMask);

		m_hSourceBitmap = GetCursorBitmap();
		::SendMessage(::GetDlgItem(this->m_hWnd,IDC_ORIGINAL),STM_SETIMAGE ,
					  (WPARAM)IMAGE_BITMAP,(LPARAM)m_hSourceBitmap);

		m_hXorMask	  =  NULL;
		m_hAndMask	  =  NULL;
		CColorCursor::GetMaskBitmaps(m_hSourceBitmap,RGB(0,0,0),m_hAndMask,m_hXorMask);
		if(NULL == m_hAndMask || NULL == m_hXorMask)
		{
			AfxMessageBox("Cannot create And and Xor masks...!");
			break;
		}

		::SendMessage(::GetDlgItem(this->m_hWnd,IDC_AND),STM_SETIMAGE ,
					 (WPARAM)IMAGE_BITMAP,(LPARAM)m_hAndMask);
		::SendMessage(::GetDlgItem(this->m_hWnd,IDC_XOR),STM_SETIMAGE ,
					 (WPARAM)IMAGE_BITMAP,(LPARAM)m_hXorMask);


		//Now create the real one
		if(NULL != m_hNewCursor)
		{
			::DestroyIcon(m_hNewCursor);
		}
		m_hNewCursor = CColorCursor::CreateCursorFromBitmap(m_hSourceBitmap,RGB(0,0,0),0,0);
		
		::SendMessage(::GetDlgItem(this->m_hWnd,IDC_CURSOR),STM_SETIMAGE ,
				 (WPARAM)IMAGE_CURSOR,(LPARAM)m_hNewCursor);


	}
	while(0);
}

HBITMAP GetCursorBitmap()
{
	HDC hMainDC = ::GetDC(NULL);
	HDC hTempDC = ::CreateCompatibleDC(hMainDC); 
	HBITMAP hTempBitmap = ::CreateCompatibleBitmap(hMainDC,WIDTH,HEIGHT);
	HBITMAP hOldBitmap	= (HBITMAP)::SelectObject(hTempDC,hTempBitmap);
	HPEN    hPen		= ::CreatePen(PS_SOLID,1,RGB(255,0,0));
	HPEN    hOldPen		= (HPEN)::SelectObject(hTempDC,hPen);
	HBRUSH  hBrush		= ::CreateSolidBrush(RGB(0,255,0));
	HBRUSH  hOldBrush	= (HBRUSH)::SelectObject(hTempDC,hBrush);

	::Rectangle(hTempDC,2,2,10,10);

	::SetTextColor(hTempDC,RGB(0,0,255));
	::SetBkMode(hTempDC,TRANSPARENT);
	::DrawText(hTempDC,"Hi",2,CRect(0,11,WIDTH,HEIGHT),DT_CENTER);
	::MoveToEx(hTempDC,0,0,NULL);
	::LineTo(hTempDC,WIDTH-1,0);
	::LineTo(hTempDC,WIDTH-1,HEIGHT-1);
	::LineTo(hTempDC,0,HEIGHT-1);
	::LineTo(hTempDC,0,0);
	
	::SelectObject(hTempDC,hOldBrush);
	::SelectObject(hTempDC,hOldPen);
	::SelectObject(hTempDC,hOldBitmap);

	::DeleteObject(hBrush);
	::DeleteObject(hPen);
	::DeleteDC(hTempDC);
	::ReleaseDC(NULL,hMainDC);

	return hTempBitmap;
}


void CColorCursorTestDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	if(NULL != m_hNewCursor)	
	{
		::SetCursor(m_hNewCursor);
	}
	
	CDialog::OnMouseMove(nFlags, point);
}
